org.apache.lucene.search

## Enum ScoreMode

- java.lang.Object
- - java.lang.Enum<ScoreMode>
  - - org.apache.lucene.search.ScoreMode

- All Implemented Interfaces:
    Serializable, Comparable<ScoreMode>

      public enum ScoreMode
      extends Enum<ScoreMode>

  Different modes of search.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `COMPLETE` Produced scorers will allow visiting all matches and get their score.
    `COMPLETE_NO_SCORES` Produced scorers will allow visiting all matches but scores won't be available.
    `TOP_DOCS` ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs
    `TOP_DOCS_WITH_SCORES` ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs.
    `TOP_SCORES` Produced scorers will optionally allow skipping over non-competitive hits using the `Scorable.setMinCompetitiveScore(float)` API.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isExhaustive()` Returns `true` if for this `ScoreMode` it is necessary to process all documents, or `false` if is enough to go through top documents only.
    `boolean` | `needsScores()` Whether this `ScoreMode` needs to compute scores.
    `static ScoreMode` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ScoreMode[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### COMPLETE

          public static final ScoreMode COMPLETE

      Produced scorers will allow visiting all matches and get their score.

    - #### COMPLETE_NO_SCORES

          public static final ScoreMode COMPLETE_NO_SCORES

      Produced scorers will allow visiting all matches but scores won't be available.

    - #### TOP_SCORES

          public static final ScoreMode TOP_SCORES

      Produced scorers will optionally allow skipping over non-competitive hits using the `Scorable.setMinCompetitiveScore(float)` API.

    - #### TOP_DOCS

          public static final ScoreMode TOP_DOCS

      ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs

    - #### TOP_DOCS_WITH_SCORES

          public static final ScoreMode TOP_DOCS_WITH_SCORES

      ScoreMode for top field collectors that can provide their own iterators, to optionally allow to skip for non-competitive docs. This mode is used when there is a secondary sort by _score.

  - ### Method Detail

    - #### values

          public static ScoreMode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ScoreMode c : ScoreMode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ScoreMode valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### needsScores

          public boolean needsScores()

      Whether this `ScoreMode` needs to compute scores.

    - #### isExhaustive

          public boolean isExhaustive()

      Returns `true` if for this `ScoreMode` it is necessary to process all documents, or `false` if is enough to go through top documents only.

Copyright © 2000-2022 Apache Software Foundation. All Rights Reserved.